package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.System;
import com.sa.ibiz.demo.demo.service.SystemService;
import com.sa.ibiz.demo.demo.service.dto.SystemSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/system")
public class SystemResource
{
	@Autowired
	private SystemService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<System> checkKey(@Validated @RequestBody System data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("系统[checkKey]操作发生错误","System",data.getSystemid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<System> create(@Validated @RequestBody System data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("系统[create]操作发生错误","System",data.getSystemid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<System> remove(@Validated @RequestBody System data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("系统[remove]操作发生错误","System",data.getSystemid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<System> getDraft(@Validated @RequestBody System data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("系统[getDraft]操作发生错误","System","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<System> get(@Validated @PathVariable String id){
		System data=new System();
		data.setSystemid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("系统[get]操作发生错误","System",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<System> update(@Validated @RequestBody System data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("系统[update]操作发生错误","System",data.getSystemid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<System>> searchDefaultPage(@Validated @RequestBody SystemSearchFilter filter){
		Page<System> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<System>> listDefault(@Validated @RequestBody SystemSearchFilter filter){
		List<System> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
